function out = comp_stat_eig(A, X, stopRule, maxeig)
  
if nargin < 3
    maxeig = 1;
end

if maxeig == 1
    mode = 'descend';
else
    mode = 'ascend';
end

if stopRule == 1
    res = @(U,AU,d) sqrt(sum((AU-bsxfun(@times,U,d')).^2))/max([1,abs(d')]);
elseif stopRule == 2
    res = @(U,AU,d) sqrt(sum((AU-bsxfun(@times,U,d')).^2))./max(1,abs(d'));
end

% resinv=@(X,AX,D)norm(bsxfun(@times,1./max(1,abs(D')), AX-X*diag(D)), 'fro');
% resinv = @(X,AX,D)max(sqrt(sum((AX-X*diag(D)).^2))./max(1,abs(D')));
% resinv = @(X,AX,D)max(sqrt(sum((AX-X*diag(D)).^2)));

[X,~] = qr(X,0);
AX = A*X; 
XAX = X'*AX;
[V,D] = eig(XAX); 

[d,p] = sort(diag(D), mode);
X = X*V(:,p); 
% AX = AX*V(:,p);
AX = A*X;
out.res = res(X,AX,d);
out.maxres = max(out.res);
out.d = d;
out.tr = sum(d);

