#!/usr/bin/python
# create job files
import glob
import os 
import math 
import datetime
import shutil
import sys, getopt

def main():

   suffix = '_mpm'  
   namelist = ['Andrews', 'C60',  'cfd1', \
           'finance', 'Ga10As10H30', 'Ga3As3H12', 'OPF3754', \
           'shallow_water1s', 'Si10H16', 'Si5H12', 'SiO', 'wathen100',\
           'Ge87H76', 'Ge99H100', 'Si41Ge41H72', 'Si87H76', 'Ga41As41H72']

   difflev = [0, 0, 3, 2, 4, 4, 0, 2, 0, 0, 0, 0, 5, 5, 5, 5, 5]
   difflev = [2, 1, 4, 4, 4, 4, 0, 4, 1, 1, 1, 1, 4, 4, 4, 4, 5]

   tollist = [6, 12]

   eiglist = [1, -1]
   steiglist = ['maxeig','mineig']

   klist =[600, 176, 707, 748, 1000, 613, 154, 819, 171, 199, 334, 304, 1000, 1000, 1000, 1000, 1000]

   SpMV_MKL = 1
   cheby = 0

   now = datetime.datetime.now()
   dname = str(now)[:10]+suffix
   #dname = str(now)[:10]+'-'+str(now.hour)+':'+str(now.minute)+suffix  
   src = os.getcwd()
   out = 'OUTPUT'
   det1 = os.path.join(src,out)
   det2 = os.path.join(det1,dname)
   dets = os.path.join(det2,'script')
   
   # create output directory
   if not os.path.isdir(det1):
       os.mkdir(det1)
   
   if not os.path.isdir(det2):
       os.mkdir(det2)
   
   if not os.path.isdir(dets):
       os.mkdir(dets)
   
   print "running jobs..."
   
   #os.chdir(dets) 
   os.chdir(src) 

   # change work directory 
   for idt in range(len(tollist)):
       tol = tollist[idt]
       for idm in range(len(eiglist)):
            maxeig = eiglist[idm]
            steig = steiglist[idm]
            for idx in range(len(namelist)):

                 
                name = namelist[idx]
                names = namelist[idx]+'_'+steig+'_MKL'+str(SpMV_MKL)+'_tol_'+str(tol)+suffix

                kk = klist[idx]

     
                if difflev[idx] == 0: 
                    runt = '0:30:00'
                elif difflev[idx] == 1: 
                    runt = '1:00:00'
                elif difflev[idx] == 2: 
                    runt = '2:00:00'
                elif difflev[idx] == 3: 
                    runt = '4:00:00'
                elif difflev[idx] == 4: 
                    runt = '8:00:00'
                else:
                    runt = '12:00:00'

                # then create batch script file
                pbsfile = 'run_'+names+'.pbs'
                
                fo = open(pbsfile, 'w')
                fo.write('#!/bin/bash -l\n\n')
                fo.write('#PBS -q regular\n')
                fo.write('#PBS -N test'+names+'\n')
                fo.write('#PBS -o test'+names+'.log\n')
                fo.write('#PBS -e test'+names+'.err\n')
                fo.write('#PBS -l mppwidth=24\n')
                fo.write('#PBS -l walltime='+runt+' \n')
                fo.write('#PBS -j oe\n')
                fo.write('#PBS -V\n\n')
                
                fo.write('cd $PBS_O_WORKDIR\n\n')
                
                fo.write('MCRROOT=\"/global/u2/z/zaiwen/Matlab2013b/v82\"\n')
                fo.write('LD_LIBRARY_PATH=.:${MCRROOT}/runtime/glnxa64\n')
                fo.write('LD_LIBRARY_PATH=${LD_LIBRARY_PATH}:${MCRROOT}/bin/glnxa64\n')
                fo.write('LD_LIBRARY_PATH=${LD_LIBRARY_PATH}:${MCRROOT}/sys/os/glnxa64\n')
                fo.write('XAPPLRESDIR=${MCRROOT}/X11/app-defaults\n\n')
                fo.write('export XAPPLRESDIR\n')
                fo.write('export LD_LIBRARY_PATH\n')
                fo.write('echo LD_LIBRARY_PATH is ${LD_LIBRARY_PATH}\n\n')

                fo.write('export OMP_NUM_THREADS=24\n\n')
                
                #aprun -n 1 -d 24 /global/u2/z/zaiwen/MPM/test_MPM_batch_mat 1 1 "[0, 1, 0, 0, 1, 1]" 0 7 "1e-12" 154 > outaa.txth
                
                #aprun -n 1 -d 24 -cc none /global/u2/z/zaiwen/MPM/test_MPM_batch_mat "-1" 1 "[0, 1, 0, 0, 1, 1]" 0 7 "1e-12" 154 > outaa.txt
                 
                fo.write('aprun -n 1 -N 1  -d 24  -cc none ' + os.path.join(src,'test_MPM_batch_mat') + ' \"' + str(maxeig) + '\" ' 
                        +str(SpMV_MKL)+ ' \"[0,0,0,0,1,1,0]\" ' + str(cheby) + ' ' \
                        + ' '+str(idx+1)+'  1e-'+str(tol)+' ' + str(kk) + ' > '  \
                        + os.path.join(det2,names) + '.out\n')

                fo.close()

                command = 'qsub '+pbsfile
                print command 
                os.system(command)


   # change work directory 
   os.chdir(src) 

if __name__ == "__main__":
   main()
