%load Pcoeffs;
if ~exist('Pc','var'), gen_Pc; Pc = P; end
% drange = input('degree range [2:15] = ');
drange = 2:7;
if isempty(drange), drange = 2:15; end

del = 0.1;
x = -1-del:1e-4:1+del; y = h0(x);
nn = length(x); kk = 1:10:nn;
fig = figure(1); plot(x(kk),y(kk),'.-')
%title('Function f1(t)','fontsize',16), grid on;
print(fig, '-depsc','results/f1.eps');
print(fig, '-dpdf','results/f1.pdf');

fig = figure(2);
[~,ie] = min(abs(x-1));
str = 'Degree %i (slope at 1 = %.2f)';

for k = drange
    [fm,xm] = min(F{k});
    fprintf('deg %2i: min f = %.4e at x = %.4f\n',k,fm,xm)
    y = (polyval(Pc{k},x)); yy{k} = y;
    plot(x,y,'.-'), grid on;
    slope = (y(ie+1)-y(ie))/(x(ie+1)-x(ie));
    title(sprintf(str,k,slope))
    axis tight; hold on;
    shg, %pause(1)
end
hold off

fig = figure(3);
nn = length(x); kk = 1:300:nn;
% plot(x(kk), yy{2}(kk), 'cs-',x(kk), yy{3}(kk), 'rx-', ...
%     x(kk), yy{4}(kk), 'mo-', x(kk), yy{5}(kk), 'b*-', ...
%     x(kk), yy{6}(kk), 'cs-.',x(kk), yy{7}(kk), 'rx-.', ...
%     'MarkerSize',5,'linewidth',2);

plot(x(kk), yy{2}(kk), 'ks-',x(kk), yy{3}(kk), 'rx-', ...
    x(kk), yy{4}(kk), 'mo-', x(kk), yy{5}(kk), 'b*-', ...
    x(kk), yy{6}(kk), 'rd-.',x(kk), yy{7}(kk), 'kx--',...
    'MarkerSize',5,'linewidth',1);

% plot(x(kk), yy{2}(kk), 'c-',x(kk), yy{3}(kk), 'r--', ...
%     x(kk), yy{4}(kk), 'm-.', x(kk), yy{5}(kk), 'b:', ...
%     x(kk), yy{6}(kk), 'c--',x(kk), yy{7}(kk), 'r-.');
grid on;
axis([min(x),max(x), min([yy{2},yy{3},yy{4},yy{5},yy{6},yy{7}]),max([yy{2},yy{3},yy{4},yy{5},yy{6},yy{7}])]);
legend('deg=2','deg=3','deg=4','deg=5','deg=6','deg=7','location','best');

str = 'Chebyshev interpolants degrees from %i to %i';
%title(sprintf(str,drange(1),drange(end')),'fontsize',16)
print(fig, '-depsc','results/poly2-7.eps');
print(fig, '-dpdf','results/poly2-7.pdf');
